From stern@rowland.harvard.edu Wed Aug 10 12:21:39 2005
Date: Wed, 10 Aug 2005 15:18:44 -0400 (EDT)
From: Alan Stern <stern@rowland.harvard.edu>
To: Greg KH <greg@kroah.com>
cc: Kernel development list <linux-kernel@vger.kernel.org>
Subject: PCI: Fix regression in pci_enable_device_bars
Message-ID: <Pine.LNX.4.44L0.0508101516220.4485-100000@iolanthe.rowland.org>

This patch (as552) fixes yet another small problem recently added.  If an
attempt to put a PCI device back into D0 fails because the device doesn't
support PCI PM, it shouldn't count as error.  Without this patch the UHCI
controllers on my Intel motherboard don't work.

Signed-off-by: Alan Stern <stern@rowland.harvard.edu>
Signed-off-by: Greg Kroah-Hartman <gregkh@suse.de>

---
 drivers/pci/pci.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

--- gregkh-2.6.orig/drivers/pci/pci.c	2005-09-08 09:20:02.000000000 -0700
+++ gregkh-2.6/drivers/pci/pci.c	2005-09-08 09:20:06.000000000 -0700
@@ -445,7 +445,7 @@ pci_enable_device_bars(struct pci_dev *d
 	int err;
 
 	err = pci_set_power_state(dev, PCI_D0);
-	if (err)
+	if (err < 0 && err != -EIO)
 		return err;
 	err = pcibios_enable_device(dev, bars);
 	if (err < 0)
